#include <Adafruit_NeoPixel.h>
#define PIN 13        // пин DI
#define NUM_LEDS 33 // число диодов
Adafruit_NeoPixel strip = Adafruit_NeoPixel(NUM_LEDS, PIN, NEO_GRB + NEO_KHZ800);

const int in3 = 2;
const int in4 = 3;
const int en2 = 5;
int i = 0;

int val=0;
int led = 2;
int delayval = 100;

const int BUTTON_INT =0;
const int svet=11;
const int off=0;
const int on=250;
volatile int selectedLED = off;
int a;


void setup() {
    pinMode(in3, OUTPUT);
    pinMode(in4, OUTPUT);
    pinMode(en2, OUTPUT);
    pinMode(9,INPUT);
    analogWrite(en2, 255);
    strip.begin();
    strip.setBrightness(50);
    strip.clear();
    strip.show();
    pinMode(led, OUTPUT);
}

void loop() {
  
Serial.println(digitalRead(9));
  if(digitalRead(9)==1)
  {
    i=i+1;
   }
   if(i == 1)
   {
     digitalWrite(in3, HIGH);
     digitalWrite(in4, LOW);
     delay(5500);
     i=i+1;
   }
   if(i == 3)
   {
     digitalWrite(in4, HIGH);
     digitalWrite(in3, LOW);
     delay(5500);
     i=i-3;
    }
    else
    {
     digitalWrite(in3, HIGH);
     digitalWrite(in4, HIGH);
    }



  val=Serial.read(); 
  if(Serial.available()>0){

    //выключение всего
    if(val==64 || val==-1){
      for(int b = 0; b < NUM_LEDS; b++ ){
        strip.setPixelColor(b, 0, 0, 0);
        strip.show();
      }
      Serial.print("end_");
      Serial.println(val);
       val=Serial.read();
      }

    //плаво загорается и тухнет(синий)
    if(val==49){
      while(val==49 || val==-1){
        for (int i = 0; i < 256; i++ ) {
          for(int b = 0; b < NUM_LEDS; b++ ){        
            strip.setPixelColor(b, 0, i, 0);
            strip.show();
          
            val=Serial.read();
            if((val>49) & val!=-1){
              b=NUM_LEDS;
              i=256;
              Serial.print(b);
             }
             Serial.println(val);
             delay(10);
           } 
          } 
          for (int i = 256; i >0; i--){
            for(int b = 0; b < NUM_LEDS; b++ ){        
              strip.setPixelColor(b, 0, i, 0);
              strip.show();
              val=Serial.read();
              if((val>49 || val<49) & val!=-1){
                b=NUM_LEDS;
                i=0;
                Serial.print(b);
              }
              // Serial.println(val);
              delay(10);
              } 
             }
        }
      }
 
      //три цвета
      if(val==50){
         while(val==51 || val==-1){
           for (int i = 0; i < NUM_LEDS / 3; i++ ) {
              strip.setPixelColor(i, 0xff0000);
              strip.show();
              val=Serial.read();
              if((val>51 || val<51) & val!=-1){
                i=NUM_LEDS/3;
              }
              delay(100);
            }
            for (int i = NUM_LEDS / 3; i < NUM_LEDS * 2 / 3; i++ ) {
              strip.setPixelColor(i, 0x00ff00);
              strip.show();
              val=Serial.read();
              if((val>51 || val<51) & val!=-1){
              i=NUM_LEDS/3*2;
              }
            delay(100);
            }
            for (int i = NUM_LEDS * 2 / 3; i < NUM_LEDS; i++ ) {
              strip.setPixelColor(i, 0x0000ff);
              strip.show();
              val=Serial.read();
              if((val>51 || val<51) & val!=-1){
                i=NUM_LEDS;
              }
              delay(100);
             }
            }
          }
          //радуга
          if(val==51){
            while(val==52 || val==-1){
              rainbowCycle(20);
            }
          }
    }
}




void rainbowCycle(uint8_t wait) {
  uint16_t i, j;
  
 //for(j=0; j<256*5; j++) {
  for(i=0; i< strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
      val=Serial.read();
     /* if((val>52 || val<52) & val!=-1){
           i=strip.numPixels();
           j=256*5;*/
           Serial.print(val);
           Serial.print("_");
         Serial.println(i);
          //}
  }
    strip.show();
    delay(wait);
 }
 
uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
   return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  } else if(WheelPos < 170) {
    WheelPos -= 85;
   return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  } else {
   WheelPos -= 170;
   return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  }
}

void swap()
{
  analogWrite(10, selectedLED);
  Serial.println("гы");
if (selectedLED == on)
selectedLED = off;
else if (selectedLED == off)
selectedLED = on;
}
